#pragma once
#include "thread/Thread.h"
#include <luna/LinkedList.h>

namespace Scheduler
{
    class Timer : public LinkedListNode<Timer>
    {
      public:
        u64 delta_ticks;
        u64 total_ticks;
        Thread* thread;
        int signo { SIGALRM };
        bool restart { false };

        u64 ticks_left();
    };

    void add_to_timer_queue(Timer* timer);
    void remove_from_timer_queue(Timer* timer);

    void tick_queue();
}
